#include "la.h"

void LA::getword(LA_symbols &SYM)
// Assemble identifier or opcode, in UPPERCASE for consistency
{ int length = 0;
  while (isalnum(Srce->ch))
  { if (length < ASM_slength)
    { SYM.str[length] = toupper(Srce->ch); length++; }
    Srce->nextch();
  }
  SYM.str[length] = '\0';
  if ( strcmp(SYM.str, "OFFSET") == 0 )
  {  SYM.sym = LA_offset;
  }
  else
	getreg(SYM);
}

void LA::getnumber(LA_symbols &SYM)
// Assemble number and store its identifier in UPPERCASE for consistency
{ int length = 0;
  while (isdigit(Srce->ch))
  { SYM.num = SYM.num * 10 + Srce->ch - '0';
    if (length < ASM_slength) { SYM.str[length] = toupper(Srce->ch); length++; }
    Srce->nextch();
  }
  SYM.str[length] = '\0';
}

void LA::getcomment(LA_symbols &SYM)
// Assemble comment
{ int length = 0;
  while (!Srce->endline())
  { if (length < ASM_slength) { SYM.str[length] = Srce->ch; length++; }
    Srce->nextch();
  }
  SYM.str[length] = '\0';
}

void LA::getreg(LA_symbols &SYM)
{
	int width= -1;
	int reg= -1;
	if (SYM.str[0]=='E') 
	{
		width=32;
		if ( SYM.str[1]=='A' && SYM.str[2]=='X' && SYM.str[3]=='\0' )
			reg=0;
		else if ( SYM.str[1]=='C' && SYM.str[2]=='X' && SYM.str[3]=='\0' )
			reg=1;
		else if ( SYM.str[1]=='D' && SYM.str[2]=='X' && SYM.str[3]=='\0' )
			reg=2;
		else if ( SYM.str[1]=='B' && SYM.str[2]=='X' && SYM.str[3]=='\0' )
			reg=3;
		else if ( SYM.str[1]=='S' && SYM.str[2]=='P' && SYM.str[3]=='\0' )
			reg=4;
		else if ( SYM.str[1]=='B' && SYM.str[2]=='P' && SYM.str[3]=='\0' )
			reg=5;
		else if ( SYM.str[1]=='S' && SYM.str[2]=='I' && SYM.str[3]=='\0' )
			reg=6;
		else if ( SYM.str[1]=='D' && SYM.str[2]=='I' && SYM.str[3]=='\0' )
			reg=7;
	}	
	else if (SYM.str[0]=='A') 
	{
		if ( SYM.str[1]=='X' && SYM.str[2]=='\0' )
			width=16, reg=0;
		else if ( SYM.str[1]=='L' && SYM.str[2]=='\0' )
			width=8, reg=0;
		else if ( SYM.str[1]=='H' && SYM.str[2]=='\0' )
			width=8, reg=4;
	}
	else if (SYM.str[0]=='C') 
	{
		if ( SYM.str[1]=='X' && SYM.str[2]=='\0' )
			width=16, reg=1;
		else if ( SYM.str[1]=='L' && SYM.str[2]=='\0' )
			width=8, reg=1;
		else if ( SYM.str[1]=='H' && SYM.str[2]=='\0' )
			width=8, reg=5;
	}
	else if (SYM.str[0]=='D') 
	{
		if ( SYM.str[1]=='X' && SYM.str[2]=='\0' )
			width=16, reg=2;
		else if ( SYM.str[1]=='L' && SYM.str[2]=='\0' )
			width=8, reg=2;
		else if ( SYM.str[1]=='H' && SYM.str[2]=='\0' )
			width=8, reg=6;
		else if ( SYM.str[1]=='I' && SYM.str[2]=='\0' )
			width=16, reg=7;
	}
	else if (SYM.str[0]=='B') 
	{
		if ( SYM.str[1]=='X' && SYM.str[2]=='\0' )
			width=16, reg=3;
		else if ( SYM.str[1]=='L' && SYM.str[2]=='\0' )
			width=8, reg=3;
		else if ( SYM.str[1]=='H' && SYM.str[2]=='\0' )
			width=8, reg=7;
		else if ( SYM.str[1]=='P' && SYM.str[2]=='\0' )
			width=16, reg=5;
	}
	else if (SYM.str[0]=='S') 
	{
		if ( SYM.str[1]=='P' && SYM.str[2]=='\0' )
			width=16, reg=4;
		else if ( SYM.str[1]=='I' && SYM.str[2]=='\0' )
			width=16, reg=6;
	}
	if (reg != -1)
	{
		SYM.sym=LA_regsym;
		SYM.num=width;
		SYM.reg=reg;
	}
}


void LA::skipeol() 
{
	if (Srce->endline())
		 Srce->nextch();
}

void LA::save_pos() 
{
   Srce->save_pos();
}

void LA::go_back() 
{
	Srce->go_back();
}

void LA::getsym(LA_symbols &SYM, bool &errors)
{ SYM.num = 0; SYM.str[0] = '\0';   // empty string
  while (Srce->ch == ' ' && !Srce->endline()) Srce->nextch();
  SYM.islabel = (Srce->startline() && isalpha(Srce->ch));
  if (Srce->ch == '\0') { SYM.sym = LA_eofsym; return; }
  if (Srce->endline()) { SYM.sym = LA_eolsym; return; }
  if (Srce->ch == ';')
    { SYM.sym = LA_comsym; getcomment(SYM); }
  else if (isalpha(Srce->ch))
    { SYM.sym = LA_idsym; getword(SYM); }
  else if (isdigit(Srce->ch))
    { SYM.sym = LA_numsym; getnumber(SYM); }
  else if (Srce->ch == '[')
    { SYM.sym = LA_LB; Srce->nextch(); }
  else if (Srce->ch == ']')
    { SYM.sym = LA_RB; Srce->nextch(); }
  else if (Srce->ch == '+')
    { SYM.sym = LA_PL; Srce->nextch(); }
  else if (Srce->ch == ',')
    { SYM.sym = LA_COMMA; Srce->nextch(); }
  else
    { SYM.sym = LA_unknown; getcomment(SYM); errors = true; }
}

LA::LA(SH* S)
{ Srce = S; Srce->nextch(); }
