#ifndef LA_H
#define LA_H

#include "misc.h"
#include "sh.h"

enum LA_symtypes {
  LA_unknown, LA_eofsym, LA_eolsym, LA_idsym, LA_regsym, LA_offset, LA_numsym, LA_comsym, LA_LB, LA_RB, LA_PL, LA_COMMA
};

struct LA_symbols {
  bool islabel;           // if in first column
  LA_symtypes sym;        // class
  ASM_strings str;        // lexeme
  int num;                // value if numeric; width if regsym
  int reg;                // register code  
};

class LA {
  public:
    void getsym(LA_symbols &SYM, bool &errors);
    // Returns the next symbol on current source line.
    // Sets errors if necessary and returns SYM.sym = unknown if no
    // valid symbol can be recognized
	void skipeol(); 
	// gets the next line from the source file
	void save_pos();
	// remember a char position within the current line 
	void go_back();
	// retreat to saved char position
    LA(SH *S);
    // Initializes scanner

  private:
    SH *Srce;
    void getword(LA_symbols &SYM);
    void getnumber(LA_symbols &SYM);
    void getcomment(LA_symbols &SYM);
    void getreg(LA_symbols &SYM);

};

#endif /*LA_H*/
