#include "sh.h"

void SH::nextch(void)
{ if (ch == '\0') return;        // input exhausted
  if (charpos == linelength)     // new line needed
  { linelength = 0; savedpos=-1; charpos = 0; ch = getc(src);
    while (ch != '\n' && !feof(src))
    { if (linelength < linemax) { line[linelength] = ch; linelength++; }
      ch = getc(src);
    }
    if (feof(src))
      line[linelength] = '\0';   // mark end with an explicit nul
    else
      line[linelength] = ' ';    // mark end with an explicit space
    linelength++;
  }
  ch = line[charpos]; charpos++; // pass back unique character
}

SH::SH(char *sourcename, char *listname, char *version)
{ src = fopen(sourcename, "r");
  if (src == NULL)
    { printf("Could not open input file\n"); exit(1); }
  lst = fopen(listname, "w");
  if (lst == NULL)
    { printf("Could not open listing file\n"); lst = stdout; }
  fprintf(lst, "%s\n\n", version);
  ch = ' '; charpos = 0; savedpos=-1; linelength = 0;
}

SH::SH()
{ src = NULL; lst = NULL; ch = ' '; charpos = 0; linelength = 0; }

SH::~SH()
{ if (src) fclose(src); src = NULL;
  if (lst) fclose(lst); lst = NULL;
}
