#include "st.h"

void ST::printsymboltable(bool &errors)
{ fprintf(Srce->lst, "\nSymbol Table\n");
  fprintf(Srce->lst, "------------\n");
  ST_entries *symentry = lastsym;
  while (symentry)
  { Srce->writetext(symentry->name, 10);
    if (!symentry->defined)
    { fprintf(Srce->lst, " --- undefined"); errors = true; }
    else
    { 
		fprintf(Srce->lst, "%s PTR ", (symentry->dsize==DS_BYTE)?" BYTE":((symentry->dsize==DS_BYTE)?" WORD":"DWORD"));
        fprintf(Srce->lst, "%08x", symentry->value);
    }
    putc('\n', Srce->lst);
    symentry = symentry->slink;
  }
  putc('\n', Srce->lst);
}

void ST::findentry(ST_entries *&symentry, char *name, bool &found)
{ symentry = lastsym;
  found = false;
  while (!found && symentry)
  { if (!strcmp(name, symentry->name))
      found = true;
    else
      symentry = symentry->slink;
  }
}

void ST::enter(char *name, int value, DATA_SIZE ds)
{ ST_entries *symentry = new ST_entries;
  sprintf(symentry->name, "%.*s", ASM_alength, name);
  symentry->value = value;
  symentry->dsize = ds;
  symentry->defined = true;
  symentry->slink = lastsym;
  lastsym = symentry;
}

void ST::valueofsymbol(char *name, int location, int &value, DATA_SIZE &ds,
                      bool &undefined)
{ ST_entries *symentry;
  bool found;
  findentry(symentry, name, found);
  undefined = !found;
  if (undefined) 
  {
    value = 0;
	ds = DS_DWORD;
  }
  else
  {
    value = symentry->value;
	ds = symentry->dsize;
  }
}

void ST::outstandingreferences(int mem[], ST_patch fix)
{ /* not needed in two pass assembly */  }

ST::ST(SH *S)
{ Srce = S; lastsym = NULL; }
