#ifndef ST_H
#define ST_H

#include "misc.h"
#include "sh.h"

typedef void (*ST_patch)(int mem[], int b, int v);

struct ST_entries {
  ASM_alfa name;          // name
  int value;         // value once defined
  DATA_SIZE dsize;	      // size of the value
  bool defined;           // true after defining occurrence encountered
  ST_entries *slink;      // to next entry
};

class ST {
  public:
    void printsymboltable(bool &errors);
    // Summarizes symbol table at end of assembly, and alters errors
    // to true if any symbols have remained undefined

    void enter(char *name, int value, DATA_SIZE ds);
    // Adds name to table with known value

    void valueofsymbol(char *name, int location, int &value, DATA_SIZE &ds,
                       bool &undefined);
    // Returns value of required name, and sets undefined if not found.
    // location is the current value of the instruction location counter

    void outstandingreferences(int mem[], ST_patch fix);
    // Walks symbol table, applying fix to outstanding references in mem

    ST(SH *S);
    // Associates table handler with source handler S (for listings)

  private:
    SH *Srce;
    ST_entries *lastsym;
    void findentry(ST_entries *&symentry, char *name, bool &found);
};

#endif /*ST_H*/
